dfs(奇偶剪枝搜索)hdu-1010

Tempter of the Bone

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 144228    Accepted Submission(s): 38486

Problem Description
The doggie found a bone in an ancient maze, which fascinated him a lot. However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.

The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper, lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.

Input
The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following:

'X': a block of wall, which the doggie cannot enter;
'S': the start point of the doggie;
'D': the Door; or
'.': an empty block.

The input is terminated with three 0's. This test case is not to be processed.

Output
For each test case, print in one line "YES" if the doggie can survive, or "NO" otherwise.

Sample Input
 
 
4 4 5S.X...X...XD....3 4 5S.X...X....D0 0 0
Sample Output
 
 
NOYES

Author
ZHANG, Zheng
 
Source

Recommend
JGShining   |   We have carefully selected several similar problems for you:   1016  1241  1242  1072  1312 
 

题意:给你一张图,一个时间限制 t 秒,问在当且仅当在 t 秒时刻时,小狗是否可以 从 S 跳到 D。

题解:从没读懂题意的 bfs 改到 dfs 又 wa,原因在于全局变量没有及时清零,又tle,原因在于没有奇偶剪枝,最             后终于过了。

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<algorithm>
using namespace std;
int n,m,t,sx,sy,ex,ey;
char s[10][10];
int v[10][10];
int leap=0;
void dfs(int x,int y,int sum){
        if(leap||sum>t)
            return;
        if(sum==t&&x==ex&&y==ey){
            leap=1;
            return;
        }

        int xx,yy;
        for(int i=0;i<4;i++){
        if(i==0){
            xx=x+1;
            yy=y;
        }
        else if(i==1){
           xx=x-1;
           yy=y;
        }
        else if(i==2){
            xx=x;
            yy=y-1;
        }
        else if(i==3){
            xx=x;
            yy=y+1;
         }
        if(xx<0||yy<0||xx>=n||yy>=m||v[xx][yy]==1||s[xx][yy]=='X')
             continue;
             v[xx][yy]=1;
             dfs(xx,yy,sum+1);
             if(leap)
                 return;
             v[xx][yy]=0;
          }
          return;
}

int main(){
        while(scanf("%d %d %d",&n,&m,&t)!=EOF){
                if(n==0&&m==0&&t==0)
                       break;
               for(int i=0;i<n;i++){
                          scanf("%s",s[i]);
                }
               for(int i=0;i<n;i++){
                     for(int j=0;j<m;j++){
                           if(s[i][j]=='S'){
                                  sx=i;
                                  sy=j;
                           }
                           if(s[i][j]=='D'){
                                  ex=i;
                                  ey=j;
                            }
                     }
              }
       int k=t-abs(sx-ex)-abs(sy-ey);         //  奇偶剪枝,abs(sx-ex)-abs(sy-ey)-->图中两点最短路
       if(k<0||k%2==1){                            //  t 比 最短路多的肯定是 一个偶数,才有可能从S走到D
              printf("NO\n");
              continue;
        }

    leap=0;        // 就因为它,错了好几发!!!!!!!!!
    memset(v,0,sizeof(v));
    v[sx][sy]=1;
    dfs(sx,sy,0);
    if(leap){
           printf("YES\n");
    }
    else
           printf("NO\n");
    }
    return 0;
}


基于bert实现关系三元组抽取python源码+数据集+项目说明.zip基于bert实现关系三元组抽取python源码+数据集+项目说明.zip基于bert实现关系三元组抽取python源码+数据集+项目说明.zip基于bert实现关系三元组抽取python源码+数据集+项目说明.zip基于bert实现关系三元组抽取python源码+数据集+项目说明.zip 个人大四的毕业设计、课程设计、作业、经导师指导并认可通过的高分设计项目,评审平均分达96.5分。主要针对计算机相关专业的正在做毕设的学生和需要项目实战练习的学习者,也可作为课程设计、期末大作业。 [资源说明] 不懂运行,下载完可以私聊问,可远程教学 该资源内项目源码是个人的毕设或者课设、作业,代码都测试ok,都是运行成功后才上传资源,答辩评审平均分达到96.5分,放心下载使用! 1、该资源内项目代码都经过测试运行成功,功能ok的情况下才上传的,请放心下载使用! 2、本项目适合计算机相关专业(如计科、人工智能、通信工程、自动化、电子信息等)的在校学生、老师或者企业员工下载学习,也适合小白学习进阶,当然也可作为毕设项目、课程设计、作业、项目初期立项演示等。 3、如果基础还行,也可在此代码基础上进行修改,以实现其他功能,也可用于毕设、课设、作业等。 下载后请首先打开README.md文件(如有),供学习参考。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值